<?php

/**
 * E2pdf License Model
 * 
 * @copyright  Copyright 2017 https://e2pdf.com
 * @license    GPL v2
 * @version    1
 * @link       https://e2pdf.com
 * @since      0.00.01
 */
if (!defined('ABSPATH')) {
    die('Access denied.');
}

class Model_E2pdf_License extends Model_E2pdf_Model {

    private $license;

    function __construct() {
        parent::__construct();
        $this->load_license();
    }

    public function get($key) {

        if (isset($this->license[$key])) {
            return $this->license[$key];
        } else {
            return false;
        }
    }

    public function load_license() {
        $model_e2pdf_api = new Model_E2pdf_Api;
        $model_e2pdf_api->set(array(
            'action' => 'license/info',
        ));
        $license = $model_e2pdf_api->request();
        $this->license = $license;

        if (isset($license['extensions'])) {

            update_option('e2pdf_extensions', $license['extensions']);

            $model_e2pdf_extension = new Model_E2pdf_Extension();

            $extensions = array();
            foreach ($license['extensions'] as $extension) {
                if (!$model_e2pdf_extension->exist($extension)) {
                    $extensions[] = $extension;
                }
            }

            if (!empty($extensions)) {
                if (!$model_e2pdf_extension->download($extensions)) {
                    update_site_option('e2pdf_force_update', true);
                }
            }
        }
    }

}
